/***********************************************************************************************************************
 *
 * blueMarine Metadata - open source media workflow
 * Copyright (C) 2007-2011 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://bluemarine.tidalwave.it
 * SCM: https://kenai.com/hg/bluemarine~metadata-src
 *
 **********************************************************************************************************************/
package it.tidalwave.metadata.makernote.provider;

import it.tidalwave.imageio.nef.NikonMakerNote3;
import it.tidalwave.imageio.raw.Directory;
import it.tidalwave.metadata.Metadata.FindOption;
import it.tidalwave.metadata.Metadata.StorageType;
import it.tidalwave.metadata.MetadataItemHolder;
import it.tidalwave.metadata.spi.MetadataItemSourceSupport;
import java.util.Collection;
import java.util.Collections;
import javax.annotation.Nonnull;
import org.openide.loaders.DataObject;

/*******************************************************************************
 *
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 ******************************************************************************/
public class MakerNoteSourceMock extends MetadataItemSourceSupport<Directory>
  {
    public MakerNoteSourceMock()
      {
        super(Directory.class, "MakerNoteSourceMock", StorageType.EXTERNAL);
      }

    @Nonnull
    public Collection<? extends MetadataItemHolder<Directory>> loadMetadataItems (final DataObject dataObject, final FindOption ... options)
      {
        final String name = dataObject.getPrimaryFile().getNameExt();
        
        if (name.contains("bad"))
          {
            return Collections.emptyList();
          }  

        final Directory makerNote = new NikonMakerNote3();
//        NikonMakerNote3 makerNote = null;
 // FIXME           makerNote.(1, "..."); // set a property to make it "available"
        return Collections.singletonList(new DirectoryMetadataItemHolder<Directory>(makerNote, getName(), "Mock", null));
      }
  }
